// ==========================================================================
// $Source: /var/lib/cvs/Givaro/src/kernel/zpz/givzpz.h,v $
// Copyright(c)'1994-2009 by The Givaro group
// This file is part of Givaro.
// Givaro is governed by the CeCILL-B license under French law
// and abiding by the rules of distribution of free software.
// see the COPYRIGHT file for more details.
// Authors: T. Gautier
// $Id: givzpz.h,v 1.8 2011-02-02 16:23:56 briceboyer Exp $
// ==========================================================================

/*!@file ring/modular.h
 * @brief   Family of arithmetics over Zpz (\f$\mathbf{Z}/p\mathbf{Z}\f$).
 */

#ifndef __GIVARO_modular_H
#define __GIVARO_modular_H

#include <givaro/givconfig.h>

#include "givaro/modular-int8.h"
#include "givaro/modular-uint8.h"
#include "givaro/modular-int16.h"
#include "givaro/modular-uint16.h"
#include "givaro/modular-int32.h"
#include "givaro/modular-uint32.h"
#include "givaro/modular-int64.h"
#include "givaro/modular-uint64.h"
#include "givaro/modular-float.h"
#include "givaro/modular-double.h"
#include "givaro/modular-integer.h"
#include "givaro/modular-inttype.h"
#include "givaro/modular-log16.h"
#include "givaro/modular-ruint.h"

#endif

